Exponential 6.0.13 Exponential Enterprise Open Source CMS - PHP Class Reference

Public Member Functions | Public Attributes | List of all members
eZMultiOption2Type Class Reference

A datatype which works with multiple options. More...

Inheritance diagram for eZMultiOption2Type:

## Public Member Functions
| __construct ()
| validateObjectAttributeHTTPInput ( $http, $base, $contentObjectAttribute)
| storeObjectAttribute ( $contentObjectAttribute)
| objectAttributeContent ( $contentObjectAttribute)
| isIndexable ()
| metaData ( $contentObjectAttribute)
| fetchObjectAttributeHTTPInput ( $http, $base, $contentObjectAttribute)
| fetchHTTPInputForGroup ( $parentOptionGroup, $http, $base, $contentObjectAttribute, $depth=0)
| customObjectAttributeHTTPAction ( $http, $action, $contentObjectAttribute, $parameters)
| productOptionInformation ( $objectAttribute, $optionID, $productItem)
| hasObjectAttributeContent ( $contentObjectAttribute)
| initializeObjectAttribute ( $contentObjectAttribute, $currentVersion, $originalContentObjectAttribute)
| fetchClassAttributeHTTPInput ( $http, $base, $classAttribute)
| validateAddToBasket ( $objectAttribute, $data, &$errors)
| isAddToBasketValidationRequired ()
| serializeContentClassAttribute ( $classAttribute, $attributeNode, $attributeParametersNode)
| unserializeContentClassAttribute ( $classAttribute, $attributeNode, $attributeParametersNode)
| serializeContentObjectAttribute ( $package, $objectAttribute)
| unserializeContentObjectAttribute ( $package, $objectAttribute, $attributeNode)
| editTemplate ( $contentObjectAttribute)
| supportsBatchInitializeObjectAttribute ()
| batchInitializeObjectAttributeData ( $classAttribute)
Public Member Functions inherited from eZDataType
| __construct ( $dataTypeString, $name, $properties=array())
| eZDataType ( $dataTypeString, $name, $properties=array())
| viewTemplate ( $contentobjectAttribute)
| informationTemplate ( $contentobjectAttribute)
| resultTemplate (&$collectionAttribute)
| isA ()
| isTranslatable ()
| attributes ()
| hasAttribute ( $attr)
| attribute ( $attr)
| isHTTPFileInsertionSupported ()
| isRegularFileInsertionSupported ()
| isSimpleStringInsertionSupported ()
| isRelationType ()
| insertHTTPFile ( $object, $objectVersion, $objectLanguage, $objectAttribute, $httpFile, $mimeData, &$result)
| insertRegularFile ( $object, $objectVersion, $objectLanguage, $objectAttribute, $filePath, &$result)
| insertSimpleString ( $object, $objectVersion, $objectLanguage, $objectAttribute, $string, &$result)
| hasStoredFileInformation ( $object, $objectVersion, $objectLanguage, $objectAttribute)
| handleDownload ( $object, $objectVersion, $objectLanguage, $objectAttribute)
| storedFileInformation ( $object, $objectVersion, $objectLanguage, $objectAttribute)
| objectDisplayInformation ( $objectAttribute, $mergeInfo=false)
| classDisplayInformation ( $classAttribute, $mergeInfo=false)
| classAttributeContent ( $classAttribute)
| onPublish ( $contentObjectAttribute, $contentObject, $publishedNodes)
| preStoreClassAttribute ( $classAttribute, $version)
| storeClassAttribute ( $classAttribute, $version)
| storeDefinedClassAttribute ( $classAttribute)
| storeModifiedClassAttribute ( $classAttribute)
| storeVersionedClassAttribute ( $classAttribute, $version)
| preStoreDefinedClassAttribute ( $classAttribute)
| preStoreModifiedClassAttribute ( $classAttribute)
| preStoreVersionedClassAttribute ( $classAttribute, $version)
| validateClassAttributeHTTPInput ( $http, $base, $classAttribute)
| fixupClassAttributeHTTPInput ( $http, $base, $classAttribute)
| customClassAttributeHTTPAction ( $http, $action, $classAttribute)
| fetchActionValue ( $action, $actionName, &$value)
| fixupObjectAttributeHTTPInput ( $http, $base, $objectAttribute)
| validateCollectionAttributeHTTPInput ( $http, $base, $objectAttribute)
| fixupCollectionAttributeHTTPInput ( $http, $base, $objectAttribute)
| fetchCollectionAttributeHTTPInput ( $collection, $collectionAttribute, $http, $base, $objectAttribute)
| handleCustomObjectHTTPActions ( $http, $attributeDataBaseName, $customActionAttributeArray, $customActionParameters)
| initializeClassAttribute ( $classAttribute)
| cloneClassAttribute ( $oldClassAttribute, $newClassAttribute)
| repairContentObjectAttribute ( $contentObjectAttribute)
| postInitializeObjectAttribute ( $objectAttribute, $currentVersion, $originalContentObjectAttribute)
| postStore ( $objectAttribute)
| trashStoredObjectAttribute ( $objectAttribute, $version=null)
| restoreTrashedObjectAttribute ( $objectAttribute)
| deleteStoredObjectAttribute ( $objectAttribute, $version=null)
| deleteStoredClassAttribute ( $classAttribute, $version=null)
| deleteNotVersionedStoredClassAttribute (eZContentClassAttribute $classAttribute)
| contentActionList ( $classAttribute)
| hasInformationCollection ()
| title ( $objectAttribute, $name=null)
| isClassAttributeRemovable ( $classAttribute)
| classAttributeRemovableInformation ( $classAttribute, $includeAll=true)
| isInformationCollector ()
| sortKey ( $objectAttribute)
| sortKeyType ()
| customSorting ()
| customSortingSQL ( $params)
| toString ( $objectAttribute)
| fromString ( $objectAttribute, $string)
| templateList ()
| postUnserializeContentObjectAttribute ( $package, $objectAttribute)
| removeRelatedObjectItem ( $contentObjectAttribute, $objectID)
| fixRelatedObjectItem ( $contentObjectAttribute, $objectID, $mode)
| createContentObjectAttributeDOMNode ( $objectAttribute)
| diff ( $old, $new, $options=false)
| getDBAFileName ()
| getDBAFilePath ( $checkExtensions=true)
| getDBAExtensionFilePath ()
| importDBDataFromDBAFile ( $dbaFilePath=false)

## Public Attributes
const | DEFAULT_NAME_VARIABLE = "_ezmultioption2_default_name_"
const | MAX_CHILD_LEVEL = 50
const | DATA_TYPE_STRING = "ezmultioption2"
Public Attributes inherited from eZDataType
| $Attributes
| $DataTypeString
| The datatype string ID, used for uniquely identifying a datatype. More...
| $Name
| The descriptive name of the datatype, usually used for displaying to the user. More...

## Additional Inherited Members
Static Public Member Functions inherited from eZDataType
static | create ( $dataTypeString)
static | registeredDataTypes ()
static | register ( $dataTypeString, $className)
static | allowedTypes ()
static | loadAndRegisterAllTypes ()
static | loadAndRegisterType ( $type)

## Detailed Description

A datatype which works with multiple options.

This allows the user to add several option choices almost as if he was adding attributes with option datatypes.

This class implements the interface for a datatype but passes most of the work over to the eZMultiOption2 class which handles parsing, storing and manipulation of multioption2s and options.

This datatype supports:

- fetch and validation of HTTP data
- search indexing
- product option information
- class title
- class serialization

Definition at line 32 of file ezmultioption2type.php.

## Constructor & Destructor Documentation

## ◆ __construct()

eZMultiOption2Type::__construct | ( |  | ) |

Constructor to initialize the datatype.

Definition at line 41 of file ezmultioption2type.php.

References ezpI18n\tr().

## Member Function Documentation

## ◆ batchInitializeObjectAttributeData()

eZMultiOption2Type::batchInitializeObjectAttributeData | ( |  | $classAttribute | ) |

Reimplemented from eZDataType.

Definition at line 664 of file ezmultioption2type.php.

References eZDB\instance().

## ◆ customObjectAttributeHTTPAction()

eZMultiOption2Type::customObjectAttributeHTTPAction | ( |  | $http,
|  |  | $action,
|  |  | $contentObjectAttribute,
|  |  | $parameters
| ) |  |

This function performs specific actions.

It has some special actions with parameters which is done by exploding $action into several parts with delimeter '_'. The first element is the name of specific action to perform. The second element will contain the key value or id.

The various operation's that is performed by this function are as follow.

- new-option - A new option is added to a multioption.
- remove-selected-option - Removes a selected option.
- new_multioption - Adds a new multioption.
- remove_selected_multioption - Removes all multioptions given by a selection list

Reimplemented from eZDataType.

Definition at line 270 of file ezmultioption2type.php.

References eZContentBrowse\browse(), and eZDebug\writeError().

## ◆ editTemplate()

eZMultiOption2Type::editTemplate | ( |  | $contentObjectAttribute | ) |

Returns
  the template name to use for editing the attribute.

Note
  Default is to return the datatype string which is OK for most datatypes, if you want dynamic templates reimplement this function and return a template name.
  The returned template name does not include the .tpl extension.

See also
  viewTemplate, informationTemplate

Reimplemented from eZDataType.

Definition at line 648 of file ezmultioption2type.php.

References eZDataType\$DataTypeString, and eZHTTPTool\instance().

## ◆ fetchClassAttributeHTTPInput()

eZMultiOption2Type::fetchClassAttributeHTTPInput | ( |  | $http,
|  |  | $base,
|  |  | $classAttribute
| ) |  |

Fetches the HTTP input for the content class attribute.

Note
  Default implementation does nothing.

Reimplemented from eZDataType.

Definition at line 525 of file ezmultioption2type.php.

## ◆ fetchHTTPInputForGroup()

eZMultiOption2Type::fetchHTTPInputForGroup | ( |  | $parentOptionGroup,
|  |  | $http,
|  |  | $base,
|  |  | $contentObjectAttribute,
|  |  | $depth = `0`
| ) |  |

Definition at line 139 of file ezmultioption2type.php.

Referenced by fetchObjectAttributeHTTPInput().

## ◆ fetchObjectAttributeHTTPInput()

eZMultiOption2Type::fetchObjectAttributeHTTPInput | ( |  | $http,
|  |  | $base,
|  |  | $contentObjectAttribute
| ) |  |

Fetches the http post var integer input and stores it in the data instance.

Reimplemented from eZDataType.

Definition at line 91 of file ezmultioption2type.php.

References fetchHTTPInputForGroup().

## ◆ hasObjectAttributeContent()

eZMultiOption2Type::hasObjectAttributeContent | ( |  | $contentObjectAttribute | ) |

Returns
  `true` if there are more than one multioption in the list.

Reimplemented from eZDataType.

Definition at line 495 of file ezmultioption2type.php.

## ◆ initializeObjectAttribute()

eZMultiOption2Type::initializeObjectAttribute | ( |  | $contentObjectAttribute,
|  |  | $currentVersion,
|  |  | $originalContentObjectAttribute
| ) |  |

Sets default multioption values.

Reimplemented from eZDataType.

Definition at line 505 of file ezmultioption2type.php.

## ◆ isAddToBasketValidationRequired()

eZMultiOption2Type::isAddToBasketValidationRequired | ( |  | ) |

Returns
  true if the datatype requires validation during add to basket procedure

Reimplemented from eZDataType.

Definition at line 600 of file ezmultioption2type.php.

## ◆ isIndexable()

eZMultiOption2Type::isIndexable | ( |  | ) |

Returns
  true if the datatype can be indexed

Reimplemented from eZDataType.

Definition at line 75 of file ezmultioption2type.php.

## ◆ metaData()

eZMultiOption2Type::metaData | ( |  | $contentObjectAttribute | ) |

Returns
  The internal XML text.

Reimplemented from eZDataType.

Definition at line 83 of file ezmultioption2type.php.

## ◆ objectAttributeContent()

eZMultiOption2Type::objectAttributeContent | ( |  | $contentObjectAttribute | ) |

Returns
  An eZMultiOption2 object which contains all the option data

Reimplemented from eZDataType.

Definition at line 68 of file ezmultioption2type.php.

## ◆ productOptionInformation()

eZMultiOption2Type::productOptionInformation | ( |  | $objectAttribute,
|  |  | $optionID,
|  |  | $productItem
| ) |  |

Finds the option which has the correct ID , if found it returns an option structure.

Reimplemented from eZDataType.

Definition at line 476 of file ezmultioption2type.php.

## ◆ serializeContentClassAttribute()

eZMultiOption2Type::serializeContentClassAttribute | ( |  | $classAttribute,
|  |  | $attributeNode,
|  |  | $attributeParametersNode
| ) |  |

Adds the necessary dom structure to the attribute parameters.

Note
  The default is to add unsupported='true' to the attribute node, meaning that the datatype does not support serializing.

Reimplemented from eZDataType.

Definition at line 605 of file ezmultioption2type.php.

## ◆ serializeContentObjectAttribute()

eZMultiOption2Type::serializeContentObjectAttribute | ( |  | $package,
|  |  | $objectAttribute
| ) |  |

Parameters

  package |
  objectAttribute | content attribute

Returns
  a DOM representation of the content object attribute

Reimplemented from eZDataType.

Definition at line 620 of file ezmultioption2type.php.

References eZDataType\createContentObjectAttributeDOMNode().

## ◆ storeObjectAttribute()

eZMultiOption2Type::storeObjectAttribute | ( |  | $contentObjectAttribute | ) |

This function calles xmlString function to create xml string and then store the content.

Reimplemented from eZDataType.

Definition at line 59 of file ezmultioption2type.php.

## ◆ supportsBatchInitializeObjectAttribute()

eZMultiOption2Type::supportsBatchInitializeObjectAttribute | ( |  | ) |

Reimplemented from eZDataType.

Definition at line 659 of file ezmultioption2type.php.

## ◆ unserializeContentClassAttribute()

eZMultiOption2Type::unserializeContentClassAttribute | ( |  | $classAttribute,
|  |  | $attributeNode,
|  |  | $attributeParametersNode
| ) |  |

Extracts values from the attribute parameters and sets it in the class attribute.

Note
  This function is called after the attribute has been stored and a second store is called after this function is done.

Reimplemented from eZDataType.

Definition at line 614 of file ezmultioption2type.php.

## ◆ unserializeContentObjectAttribute()

eZMultiOption2Type::unserializeContentObjectAttribute | ( |  | $package,
|  |  | $objectAttribute,
|  |  | $attributeNode
| ) |  |

Unserialize contentobject attribute

Parameters

  package |
  objectAttribute | contentobject attribute object
  attributeNode | ezdomnode object

Reimplemented from eZDataType.

Definition at line 633 of file ezmultioption2type.php.

## ◆ validateAddToBasket()

eZMultiOption2Type::validateAddToBasket | ( |  | $objectAttribute,
|  |  | $data,
|  | & | $errors
| ) |  |

Validates the input for an object attribute during add to basket process and returns a validation state as defined in eZInputValidator.

Reimplemented from eZDataType.

Definition at line 535 of file ezmultioption2type.php.

References eZInputValidator\STATE_ACCEPTED, eZInputValidator\STATE_INVALID, and ezpI18n\tr().

## ◆ validateObjectAttributeHTTPInput()

eZMultiOption2Type::validateObjectAttributeHTTPInput | ( |  | $http,
|  |  | $base,
|  |  | $contentObjectAttribute
| ) |  |

Validates the input for this datatype.

Returns
  True if input is valid.

Reimplemented from eZDataType.

Definition at line 51 of file ezmultioption2type.php.

References eZInputValidator\STATE_ACCEPTED.

## Member Data Documentation

## ◆ DATA_TYPE_STRING

const eZMultiOption2Type::DATA_TYPE_STRING = "ezmultioption2"

Definition at line 36 of file ezmultioption2type.php.

## ◆ DEFAULT_NAME_VARIABLE

const eZMultiOption2Type::DEFAULT_NAME_VARIABLE = "_ezmultioption2_default_name_"

Definition at line 34 of file ezmultioption2type.php.

## ◆ MAX_CHILD_LEVEL

const eZMultiOption2Type::MAX_CHILD_LEVEL = 50

Definition at line 35 of file ezmultioption2type.php.

The documentation for this class was generated from the following file:

- ezmultioption2type.php

Copyright © 1998 – 2026 7x. All rights reserved. Licensed under the GNU GPLv2+.